Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 74081)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 74082)
@@ -756,2 +756,55 @@
     pPainter->restore();
 }
+
+/* static */
+void UIDetailsElement::configurePainterShape(QPainter *pPainter,
+                                          const QStyleOptionGraphicsItem *pOptions,
+                                          int iRadius)
+{
+    /* Rounded corners? */
+    if (iRadius)
+    {
+        /* Setup clipping: */
+        QPainterPath roundedPath;
+        roundedPath.addRoundedRect(pOptions->rect, iRadius, iRadius);
+        pPainter->setRenderHint(QPainter::Antialiasing);
+        pPainter->setClipPath(roundedPath);
+    }
+}
+
+/* static */
+void UIDetailsElement::paintFrameRect(QPainter *pPainter, const QRect &rect, int iRadius)
+{
+    pPainter->save();
+    QPalette pal = QApplication::palette();
+    QColor base = pal.color(QPalette::Active, QPalette::Window);
+    pPainter->setPen(base.darker(160));
+    if (iRadius)
+        pPainter->drawRoundedRect(rect, iRadius, iRadius);
+    else
+        pPainter->drawRect(rect);
+    pPainter->restore();
+}
+
+/* static */
+void UIDetailsElement::paintPixmap(QPainter *pPainter, const QRect &rect, const QPixmap &pixmap)
+{
+    pPainter->drawPixmap(rect, pixmap);
+}
+
+/* static */
+void UIDetailsElement::paintText(QPainter *pPainter, QPoint point,
+                              const QFont &font, QPaintDevice *pPaintDevice,
+                              const QString &strText, const QColor &color)
+{
+    /* Prepare variables: */
+    QFontMetrics fm(font, pPaintDevice);
+    point += QPoint(0, fm.ascent());
+
+    /* Draw text: */
+    pPainter->save();
+    pPainter->setFont(font);
+    pPainter->setPen(color);
+    pPainter->drawText(point, strText);
+    pPainter->restore();
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.h	(revision 74081)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.h	(revision 74082)
@@ -283,4 +283,15 @@
         /** Paints background using specified @a pPainter and certain @a pOptions. */
         void paintBackground(QPainter *pPainter, const QStyleOptionGraphicsItem *pOptions);
+
+        /** Configures painting shape using passed @a pPainter, @a pOptions and spified @a iRadius. */
+        static void configurePainterShape(QPainter *pPainter, const QStyleOptionGraphicsItem *pOptions, int iRadius);
+        /** Paints frame @a rect using passed @a pPainter and spified @a iRadius. */
+        static void paintFrameRect(QPainter *pPainter, const QRect &rect, int iRadius);
+        /** Paints @a pixmap using passed @a pPainter and spified @a rect. */
+        static void paintPixmap(QPainter *pPainter, const QRect &rect, const QPixmap &pixmap);
+        /** Paints @a strText using passed @a pPainter, @a font, @a color, @a pPaintDevice and spified @a point. */
+        static void paintText(QPainter *pPainter, QPoint point,
+                              const QFont &font, QPaintDevice *pPaintDevice,
+                              const QString &strText, const QColor &color);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.cpp	(revision 74081)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.cpp	(revision 74082)
@@ -276,57 +276,4 @@
 }
 
-/* static */
-void UIDetailsItem::configurePainterShape(QPainter *pPainter,
-                                          const QStyleOptionGraphicsItem *pOptions,
-                                          int iRadius)
-{
-    /* Rounded corners? */
-    if (iRadius)
-    {
-        /* Setup clipping: */
-        QPainterPath roundedPath;
-        roundedPath.addRoundedRect(pOptions->rect, iRadius, iRadius);
-        pPainter->setRenderHint(QPainter::Antialiasing);
-        pPainter->setClipPath(roundedPath);
-    }
-}
-
-/* static */
-void UIDetailsItem::paintFrameRect(QPainter *pPainter, const QRect &rect, int iRadius)
-{
-    pPainter->save();
-    QPalette pal = QApplication::palette();
-    QColor base = pal.color(QPalette::Active, QPalette::Window);
-    pPainter->setPen(base.darker(160));
-    if (iRadius)
-        pPainter->drawRoundedRect(rect, iRadius, iRadius);
-    else
-        pPainter->drawRect(rect);
-    pPainter->restore();
-}
-
-/* static */
-void UIDetailsItem::paintPixmap(QPainter *pPainter, const QRect &rect, const QPixmap &pixmap)
-{
-    pPainter->drawPixmap(rect, pixmap);
-}
-
-/* static */
-void UIDetailsItem::paintText(QPainter *pPainter, QPoint point,
-                              const QFont &font, QPaintDevice *pPaintDevice,
-                              const QString &strText, const QColor &color)
-{
-    /* Prepare variables: */
-    QFontMetrics fm(font, pPaintDevice);
-    point += QPoint(0, fm.ascent());
-
-    /* Draw text: */
-    pPainter->save();
-    pPainter->setFont(font);
-    pPainter->setPen(color);
-    pPainter->drawText(point, strText);
-    pPainter->restore();
-}
-
 
 /*********************************************************************************************************************************
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.h	(revision 74081)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.h	(revision 74082)
@@ -137,18 +137,4 @@
     /** @} */
 
-    /** @name Painting stuff.
-      * @{ */
-        /** Configures painting shape using passed @a pPainter, @a pOptions and spified @a iRadius. */
-        static void configurePainterShape(QPainter *pPainter, const QStyleOptionGraphicsItem *pOptions, int iRadius);
-        /** Paints frame @a rect using passed @a pPainter and spified @a iRadius. */
-        static void paintFrameRect(QPainter *pPainter, const QRect &rect, int iRadius);
-        /** Paints @a pixmap using passed @a pPainter and spified @a rect. */
-        static void paintPixmap(QPainter *pPainter, const QRect &rect, const QPixmap &pixmap);
-        /** Paints @a strText using passed @a pPainter, @a font, @a color, @a pPaintDevice and spified @a point. */
-        static void paintText(QPainter *pPainter, QPoint point,
-                              const QFont &font, QPaintDevice *pPaintDevice,
-                              const QString &strText, const QColor &color);
-    /** @} */
-
 private:
 